using System;

namespace RockyJupiter.Mobilengine.Service
{
    //Implement the service interface
    class WdxService: IWdx
    {
        private static string LastDacsid;

        //Make the web service aware of the security key
        private static string keyAstroOut = "Very secret key";
        
        public void EnqueueDacs(Dacs dacs)
        {
            //Throw an exception for messages whose key don't match
            if (dacs.Key != keyAstroOut)
            {
                Console.WriteLine("Authentication failed for key {0}", dacs.Key);
                throw new FaultException<EnqueueDacsFail>(new EnqueueDacsFail { dacsid = dacs.dacsid, Message = "Dacs authentication failed" });
            }
            
            //Ignore the message if it is a duplicate
            if (dacs.dacsid == LastDacsid)
            {
                Console.WriteLine("Dacs {0} has already been processed, ignoring.");
                return;
            }
            //Store the package ID of the last received message
            LastDacsid = dacs.dacsid;
            
            //Write the contents of the incoming message to the console
            Console.WriteLine("Processing {0}:", dacs.dacsid);
            var statusUpdate = dacs.Content.Item;
            Console.WriteLine(
                "Driver {0} changed the status of assignment {1} from {2} to {3}.",
                statusUpdate.driver.Value,
                statusUpdate.assignmentId,
                statusUpdate.oldStatus,
                statusUpdate.newStatus);
        }
    }
}
